/* sys/sem.h (emx+gcc) */

#ifndef _SYS_SEM_H
#define _SYS_SEM_H

#include <sys/ipc.h>

struct sem {
	unsigned short	semval;
	pid_t		sempid;
	unsigned short	semncnt;
	unsigned short	semzcnt;
};

struct semid_ds {
	struct ipc_perm	sem_perm;
	struct sem	*sem_base;
	unsigned short	sem_nsems;
	time_t		sem_otime;
	time_t		sem_ctime;
};

struct sembuf {
	unsigned short	sem_num;
	short		sem_op;
	short		sem_flg;
};

#define SEM_UNDO	010000
#define MAX_SOPS	20

union semun {
	int		val;
	struct semid_ds	*buf;
	unsigned short	*array;
};

/* some defines */
#define GETNCNT		5
#define GETPID		6
#define	GETVAL		7
#define	GETALL		8
#define	GETZCNT		9
#define	SETVAL		10
#define	SETALL		11

#define SEM_R		IPC_R
#define SEM_A		IPC_W

#if defined(__cplusplus)
extern "C" {
#endif

int semctl (int, int, int, union semun);
int semget (key_t, int, int);
int semop (int, struct sembuf *,unsigned);

#if defined(__cplusplus)
}
#endif

#endif /* !_SYS_SEM_H */
